SystemOrganization addCategory: #'Curium-Core'!

!ByteString methodsFor: '*curium-core' stamp: 'BernardoContreras 7/3/2012 20:53'!
dQuoted
	"return a double quoted string"

	^ '"' , self , '"'! !

Object subclass: #CMCommand
	instanceVariableNames: 'cmdName args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Curium-Core'!

!CMCommand commentStamp: '<historical>' prior: 0!
a cmake command!

!CMCommand class methodsFor: 'instance creation' stamp: 'BernardoContreras 6/28/2012 13:36'!
named: aCmdName
	^ self basicNew initializeName: aCmdName! !

!CMCommand methodsFor: 'accessing' stamp: 'BernardoContreras 7/3/2012 22:11'!
add: anArgument
	" add an argument "

	^ args add: anArgument! !

!CMCommand methodsFor: 'accessing' stamp: 'BernardoContreras 7/3/2012 22:15'!
addAll: aCollectionOfArguments
	" add all arguments "

	^ args addAll: aCollectionOfArguments! !

!CMCommand methodsFor: 'initialize-release' stamp: 'BernardoContreras 7/3/2012 21:32'!
initializeName: aCommandNamed
	cmdName := aCommandNamed.
	args := OrderedCollection new! !

!CMCommand methodsFor: 'printing' stamp: 'BernardoContreras 7/3/2012 21:33'!
printArgsOn: aStream
	args do: [ :each | aStream nextPutAll: each ] separatedBy: [ aStream space ]! !

!CMCommand methodsFor: 'printing' stamp: 'BernardoContreras 7/3/2012 21:33'!
printOn: aStream
	aStream
		nextPutAll: cmdName;
		nextPut: $(.
	self printArgsOn: aStream.
	aStream nextPut: $)! !

Object subclass: #CMMakeGenerator
	instanceVariableNames: 'cmds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Curium-Core'!

!CMMakeGenerator commentStamp: '<historical>' prior: 0!
CMake Generator.

Example
| gen |
gen := CMMakeGenerator v2dot6.
gen project add: 'Hello'.
gen!

!CMMakeGenerator class methodsFor: 'instance creation' stamp: 'BernardoContreras 6/28/2012 00:04'!
v2dot6
	^ CMMakeV2dot6 new! !

!CMMakeGenerator methodsFor: 'private' stamp: 'BernardoContreras 7/3/2012 22:16'!
addCmd: aCommand
	^ cmds add: aCommand! !

!CMMakeGenerator methodsFor: 'private' stamp: 'BernardoContreras 7/3/2012 22:16'!
commandNamed: name
	^ self addCmd: (CMCommand named: name)! !

!CMMakeGenerator methodsFor: 'initialize-release' stamp: 'BernardoContreras 6/27/2012 21:11'!
initialize
	cmds := OrderedCollection new! !

!CMMakeGenerator methodsFor: 'printing' stamp: 'BernardoContreras 7/3/2012 22:16'!
printCmdsOn: aStream
	cmds
		do: [ :each | 
			each printOn: aStream.
			aStream
				cr;
				lf ]! !

!CMMakeGenerator methodsFor: 'printing' stamp: 'BernardoContreras 7/3/2012 22:16'!
printOn: aStream
	super printOn: aStream.
	aStream
		space;
		nextPut: $[;
		cr.
	self printCmdsOn: aStream.
	aStream nextPut: $]! !

!CMMakeGenerator methodsFor: 'accessing' stamp: 'BernardoContreras 7/3/2012 22:16'!
writeOn: aStream
	self printCmdsOn: aStream! !

!CMMakeGenerator methodsFor: 'accessing' stamp: 'BernardoContreras 7/7/2012 03:21'!
writeTo: aFileReference 
	aFileReference ensureDeleted writeStreamDo: [:stream | self writeOn: stream ].
	! !

CMMakeGenerator subclass: #CMMakeV2dot6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Curium-Core'!

!CMMakeV2dot6 commentStamp: '<historical>' prior: 0!
http://www.cmake.org/cmake/help/cmake2.6docs.html!

!CMMakeV2dot6 methodsFor: 'commands' stamp: 'BernardoContreras 6/28/2012 16:15'!
addExecutable
	^ self commandNamed: 'add_executable'! !

!CMMakeV2dot6 methodsFor: 'commands' stamp: 'BernardoContreras 7/7/2012 20:37'!
addTest
	^ self commandNamed: 'add_test'! !

!CMMakeV2dot6 methodsFor: 'commands' stamp: 'BernardoContreras 7/7/2012 20:45'!
enableTesting
	^ self commandNamed: 'enable_testing'! !

!CMMakeV2dot6 methodsFor: 'initialize-release' stamp: 'BernardoContreras 7/3/2012 22:14'!
initialize
	super initialize.
	self minimumRequired
		addAll:
			{'VERSION'.
			'2.6'}! !

!CMMakeV2dot6 methodsFor: 'commands' stamp: 'BernardoContreras 6/27/2012 23:50'!
minimumRequired
	^ self commandNamed: 'cmake_minimum_required'! !

!CMMakeV2dot6 methodsFor: 'commands' stamp: 'BernardoContreras 6/27/2012 23:50'!
project
	^ self commandNamed: 'project'! !

!CMMakeV2dot6 methodsFor: 'commands' stamp: 'BernardoContreras 7/7/2012 21:25'!
setTestsProperties
	^ self commandNamed: 'set_tests_properties'! !

Object subclass: #CMReadme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Curium-Core'!

!CMReadme commentStamp: 'BernardoContreras 7/3/2012 23:27' prior: 0!
Name: Curium
Symbol: Cm
http://en.wikipedia.org/wiki/Curium

cmake - Cross-Platform Makefile Generator.

cmake_minimum_required (VERSION 2.6)
project (Hello)
add_executable(Hello main2.c)

=>

cmake := CMMakeGenerator v2dot6.
cmake project add: 'Hello'.
cmake addExecutable add: 'Hello'; add: 'main.c'.
cmake!
